/*
	ConvSpecChars.js

	from http://www.macromedia.com/devnet/server_archive/articles/roll_your_own_hs_studio.html
	by Dan Hulse

	Takes the current selection, and replaces special characters 
	with their general entity equivalent
	
	E.g., 
	
	<html> ..becomes.. &gt;html&lt;
	
*/

function Main() {

	var aChars = new Array(4);
	var aRepls = new Array(4);
	var SelStr = '';
	var NewStr = '';
	var s      = '';
	var i;
	
	// Initialize search/replace pairs
	// Note that order is important (e.g., replace '&' first!!)
	aChars[0] = '&';
	aRepls[0] = '&amp;';
	
	aChars[1] = '<';
	aRepls[1] = '&lt;';
	
	aChars[2] = '>';
	aRepls[2] = '&gt;';
	
	aChars[3] = '"';
	aRepls[3] = "&quot;";

	with (Application){
		with (ActiveDocument){
			if (SelLength == 0){
				MessageBox('One or more characters must be selected.', 'Error', 0);
				return;
			}

			SelStr = SelText;
			
			for (i = 0; i < SelStr.length; i++){
				s = SelStr.substr(i, 1);

				iItem = ArrFind(aChars, s);
				
				if (iItem > -1)
					NewStr = NewStr + aRepls[iItem]
				else 
					NewStr = NewStr + s;
			}
			
			SelText = NewStr;
		}
	}
}


function ArrFind(aArray, sSearch){
	var i;
	var result = -1;
	var s;

	for (i = 0; i < aArray.length; i++){
		s = aArray[i];
		if (s == sSearch){
			result = i;
			break;
		}
	}

	return(result);
}
